﻿Imports System.Collections.Generic
Imports System.Linq
Imports System.Text
Imports System.Collections.ObjectModel
Imports System.Collections.Specialized
Imports System.ComponentModel

Public Class DataItemCollection
  Inherits ObservableCollection(Of DataItem)

  Protected Overrides Sub InsertItem(index As Integer, item As DataItem)
    Me.AdoptItem(item)
	MyBase.InsertItem(index, item)
  End Sub
  Protected Overrides Sub RemoveItem(index As Integer)
    Me.DiscardItem(Me(index))
    MyBase.RemoveItem(index)
  End Sub
  Protected Overrides Sub SetItem(index As Integer, item As DataItem)
    Me.AdoptItem(item)
    MyBase.SetItem(index, item)
  End Sub
  Protected Overrides Sub ClearItems()
    For Each item As DataItem In Me
      Me.DiscardItem(item)
    Next
    MyBase.ClearItems()
  End Sub
  Private Sub AdoptItem(item As DataItem)
    item.SetOwner(Me)
  End Sub
  Private Sub DiscardItem(item As DataItem)
    item.SetOwner(Nothing)
    item.SetChildren(Nothing)
  End Sub
End Class
