﻿Imports System.Windows.Data
Imports System.Linq
Imports System.Collections.ObjectModel
Imports System.Collections.Specialized


Public Class HierarchyConverter
  Implements IValueConverter

#Region "IValueConverter Members"

Private collectionToNewItemsMap As New Dictionary(Of Object, List(Of ObservableCollection(Of DataItem)))()

  Public Function convert(value As Object, targetType As System.Type, parameter As Object, culture As System.Globalization.CultureInfo) As Object Implements System.Windows.Data.IValueConverter.Convert
	' We are binding an item
	Return Me.InnerConvert(value)

  End Function

  Private Function InnerConvert(value As Object) As Object
  Dim item As DataItem = TryCast(value, DataItem)
	If item IsNot Nothing Then
	  If item.Owner IsNot Nothing Then
		item.SetChildren(New ObservableCollection(Of DataItem)(item.Owner.Where(Function(i) i.ParentId = item.Id)))
	  End If
	  Return item.Children
	End If

	' We are binding the treeview
	Dim items As DataItemCollection = TryCast(value, DataItemCollection)
	If items IsNot Nothing Then
		Dim observableItems = TryCast(items, INotifyCollectionChanged)
		Dim newItems = New ObservableCollection(Of DataItem)(items.Where(Function(i) i.ParentId = 0))
		If observableItems IsNot Nothing Then
			If Not Me.collectionToNewItemsMap.ContainsKey(observableItems) Then
				AddHandler observableItems.CollectionChanged, AddressOf Me.observableItems_CollectionChanged
			End If
			If Not Me.collectionToNewItemsMap.ContainsKey(observableItems) Then
				Me.collectionToNewItemsMap(observableItems) = New List(Of ObservableCollection(Of DataItem))
			End If
			Me.collectionToNewItemsMap(observableItems).Add(newItems)
		End If
		Return newItems
	End If
	Return Nothing
	End Function

	Private Sub observableItems_CollectionChanged(sender As Object, e As NotifyCollectionChangedEventArgs)
		For Each item As ObservableCollection(Of DataItem) In Me.collectionToNewItemsMap(sender)
			If item IsNot Nothing AndAlso e.Action = NotifyCollectionChangedAction.Add Then
				item.Add(e.NewItems(0))
			End If
		Next
	End Sub

  Public Function ConvertBack(value As Object, targetType As System.Type, parameter As Object, culture As System.Globalization.CultureInfo) As Object Implements System.Windows.Data.IValueConverter.ConvertBack
	Throw New NotImplementedException()
  End Function

#End Region
End Class

